---
title: Checking when a deadline is due
slug: Web/API/IndexedDB_API/Checking_when_a_deadline_is_due
tags:
  - Apps
  - Date
  - Example
  - Guide
  - IndexedDB
  - deadline
---
<div>{{DefaultAPISidebar("IndexedDB")}}</div><div class="summary">
<p>In this article we look at a complex example involving checking the current time and date against a deadline stored via IndexedDB. The main complication here is checking the stored deadline info (month, hour, day, etc.) against the current time and date taken from a <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date">Date</a> object.</p>
</div>

<p><img alt="A screenshot of the sample app. A red main title saying To do app, a test to-do item, and a red form for users to enter new tasks" src="https://mdn.mozillademos.org/files/6319/to-do-app.png" style="float: left; height: 569px; margin-bottom: 20px; margin-right: 20px; width: 320px;"></p>

<p>The main example application we will be referring to in this article is <strong>To-do list notifications</strong>, a simple to-do list application that stores task titles and deadline times and dates via <a href="/en-US/docs/Web/API/IndexedDB_API">IndexedDB</a>, and then provides users with notifications when deadline dates are reached, via the <a href="/en-US/docs/Web/API/notification">Notification</a>, and <a href="/en-US/docs/Web/Guide/API/Vibration">Vibration</a> APIs. You can <a href="https://github.com/chrisdavidmills/to-do-notifications/tree/gh-pages">download the To-do list notifications app from github</a> and play around with the source code, or <a href="https://mdn.github.io/to-do-notifications/">view the app running live</a>.</p>

<h2 id="The_basic_problem">The basic problem</h2>

<p>In the to-do app, we wanted to first record time and date information in a format that is both machine readable and human understandable when displayed, and then check whether each time and date is occurring at the current moment. Basically, we want to check what the time and date is right now, and then check each stored event to see if any of their deadlines match the current time and date. If they do, we want to let the user know with some kind of notification.</p>

<p>This would be easy if we were just comparing two {{jsxref("Global_Objects/Date", "Date")}} objects, but of course humans don't want to enter deadline information in the same format JavaScript understands. Human-readable dates are quite different, with a number of different representations.</p>

<h3 id="Recording_the_date_information">Recording the date information</h3>

<p>To provide a reasonable user experience on mobile devices, and to cut down on ambiguities, I decided to create an HTML form with:</p>

<p><img alt="The form of the to-do app, containing fields to fill in a task title, and minute, hour, day, month and year values for the deadline." src="https://mdn.mozillademos.org/files/6321/to-do-app-form2.png" style="float: left; height: 311px; margin-bottom: 20px; margin-right: 40px; width: 288px;"></p>

<ul>
 <li>A text input for entering a title for your to-do list. This is the least avoidable bit of user typing.</li>
 <li>Number inputs for the hour and minute parts of the deadline. On browsers that support <code>type="number"</code>, you get a nice little up and down arrow number picker. On mobile platforms you tend to get a numeric keypad for entering data, which is helpful. On others you just get a standard text input, which is okay.</li>
 <li>{{HTMLElement("select")}} elements for inputting the day, month and year of the deadline. Because these values are the most ambiguous for users to enter (7, sunday, sun? 04, 4, April, Apr? 2013, '13, 13?), I decided the best solution was to give them a choice to pick from, which also saves on annoying typing for mobile users. The days are recorded as numerical days of the month, the months are recorded as full month names, and the years are recorded as full four digit year numbers.</li>
</ul>

<p>When the form's submit button is pressed, we run the <code>addData()</code> function, which starts like this:</p>

<pre class="brush: js">function addData(e) {
  e.preventDefault();

  if(title.value == '' || hours.value == null || minutes.value == null || day.value == '' || month.value == '' || year.value == null) {
    note.innerHTML += '&lt;li&gt;Data not submitted — form incomplete.&lt;/li&gt;';
    return;
  }
</pre>

<p>In this segment, we check to see if the form fields have all been filled in. If not, we drop a message into our developer notifications pane (see the bottom left of the app UI) to tell the user what is going on, and exit out of the function. This step is mainly for browsers that don't support HTML form validation (I have used the <code>required</code> attribute in my HTML to force validation, in those that do.)</p>

<pre class="brush: js">   else {
    var newItem = [
      {
        taskTitle: title.value,
        hours    : hours.value,
        minutes  : minutes.value,
        day      : day.value,
        month    : month.value,
        year     : year.value,
        notified : "no"
      }
    ];

    // open a read/write db transaction, ready for adding the data
    var transaction = db.transaction(["toDoList"], "readwrite");

    // report on the success of opening the transaction
    transaction.oncomplete = function(event) {
      note.innerHTML += '&lt;li&gt;Transaction opened for task addition.&lt;/li&gt;';
    };

    transaction.onerror = function(event) {
      note.innerHTML += '&lt;li&gt;Transaction not opened due to error. Duplicate items not allowed.&lt;/li&gt;';
    };

    // create an object store on the transaction
    var objectStore = transaction.objectStore("toDoList");

    // add our newItem object to the object store
    var request = objectStore.add(newItem[0]); </pre>

<p>In this section we create an object called <code>newItem</code> that stores the data in the format required to insert it into the database. The next few lines open the database transaction and provide messages to notify the user if this was successful or failed.Then an <code>objectStore</code> is created into which the new item is added. The <code>notified</code> property of the data object indicates that the to-do list item's deadline has not yet come up and been notified - more on this later!</p>

<div class="note">
<p><strong>Note:</strong> The <code>db</code> variable stores a reference to the IndexedDB database instance; we can then use various properties of this variable to manipulate the data.</p>
</div>

<pre class="brush: js">
    request.onsuccess = function(event) {

      note.innerHTML += '&lt;li&gt;New item added to database.&lt;/li&gt;';

      title.value = '';
      hours.value = null;
      minutes.value = null;
      day.value = 01;
      month.value = 'January';
      year.value = 2020;
    };
  }</pre>

<p>This next section creates a log message to say the new item addition is successful, and resets the form so it's ready for the next task to be entered.</p>

<pre class="brush: js">
  // update the display of data to show the newly added item, by running displayData() again.
  displayData();
};</pre>

<p>Last of all, we run the <code>displayData()</code> function, which updates the display of data in the app to show the new task that was just entered.</p>

<h3 id="Checking_whether_a_deadline_has_been_reached">Checking whether a deadline has been reached</h3>

<p>At this point our data is in the database; now we want to check whether any of the deadlines have been reached. This is done by our <code>checkDeadlines()</code> function:</p>

<pre class="brush: js">function checkDeadlines() {
  var now = new Date();</pre>

<p>First we grab the current date and time by creating a blank <code>Date</code> object. Easy huh? It's about to get a bit more complex.</p>

<pre class="brush: js">  var minuteCheck  = now.getMinutes();
  var hourCheck    = now.getHours();
  var dayCheck     = now.getDate();
  var monthCheck   = now.getMonth();
  var yearCheck    = now.getFullYear();
</pre>

<p>The <code>Date</code> object has a number of methods to extract various parts of the date and time inside it. Here we fetch the current minutes (gives an easy numerical value), hours (gives an easy numerical value), day of the month (<code>getDate()</code> is needed for this, as <code>getDay()</code> returns the day of the week, 1-7), month (returns a number from 0-11, see below), and year (<code>getFullYear()</code> is needed; <code>getYear()</code> is deprecated, and returns a weird value that is not much use to anyone!)</p>

<pre class="brush: js">   var objectStore = db.transaction(['toDoList'], "readwrite").objectStore('toDoList');

  objectStore.openCursor().onsuccess = function(event) {
    var cursor = event.target.result;

    if(cursor) {</pre>

<p>Next we create another IndexedDB <code>objectStore</code>, and use the <code>openCursor()</code> method to open a cursor, which is basically a way in IndexedDB to iterate through all the items in the store. We then loop through all the items in the cursor for as long as there is a valid item left in the cursor.</p>

<pre class="brush: js">      switch(cursor.value.month) {
        case "January":
          var monthNumber = 0;
          break;
        case "February":
          var monthNumber = 1;
          break;

        // other lines removed from listing for brevity

        case "December":
          var monthNumber = 11;
          break;
        default:
          alert('Incorrect month entered in database.');
      }</pre>

<p>The first thing we do is convert the month names we have stored in the database into a month number that JavaScript will understand. As we saw before, the JavaScript <code>Date</code> object creates month values as a number between 0 and 11.    </p>

<pre class="brush: js">      if(+(cursor.value.hours) == hourCheck &amp;&amp;
         +(cursor.value.minutes) == minuteCheck &amp;&amp;
         +(cursor.value.day) == dayCheck &amp;&amp;
         monthNumber == monthCheck &amp;&amp;
         cursor.value.year == yearCheck &amp;&amp;
         notified == "no") {

        // If the numbers all do match, run the createNotification()
        // function to create a system notification
        createNotification(cursor.value.taskTitle);
      }</pre>

<p>With the current time and date segments that we want to check against the IndexedDB stored values all assembled, it is time to perform the checks. We want all the values to match before we show the user some kind of notification to tell them their deadline is up.</p>

<p>The <code>+</code> operator in this case converts numbers with leading zeros into their non leading zero equivalents, e.g. 09 -&gt; 9. This is needed because JavaScript <code>Date</code> number values never have leading zeros, but our data might.</p>

<p>The <code>notified == "no"</code> check is designed to make sure you will only get one notification per to-do item. When a notification is fired for each item object, its <code>notification</code> property is set to <code>"yes"</code> so this check will not pass on the next iteration, via the following code inside the <code>createNotification()</code> function (read <a href="/en-US/docs/Web/API/IndexedDB_API/Using_IndexedDB">Using IndexedDB</a> for an explanation):</p>

<pre class="brush: js">    // now we need to update the value of notified to "yes" in this particular data object, so the
    // notification won't be set off on it again

    // first open up a tranaction as usual
    var objectStore = db.transaction(['toDoList'], "readwrite").objectStore('toDoList');

    // get the to-do list object that has this title as it's title
    var request = objectStore.get(title);

    request.onsuccess = function() {
      // grab the data object returned as the result
      var data = request.result;

      // update the notified value in the object to "yes"
      data.notified = "yes";

      // create another request that inserts the item back into the database
      var requestUpdate = objectStore.put(data);

      // when this new request succeeds, run the displayData() function again to update the display
      requestUpdate.onsuccess = function() {
        displayData();
      }</pre>

<p>If the checks all match, we then run the <code>createNotification()</code> function to provide a notification to the user.</p>

<pre class="brush: js">       cursor.continue();
    }
  }
}</pre>

<p>The last line of the function moves the cursor on, which causes the above deadline checking mechanism to be run for the next task stored in the IndexedDB.</p>

<h3 id="Keep_on_checking!">Keep on checking!</h3>

<p>Of course, it is no use to just run the above deadline checking function once! We want to keep constantly checking all the deadlines to see if any of them are being reached. To do this, we are using <code>setInterval()</code> to run <code>checkDeadlines()</code> once per second:</p>

<pre class="brush: js">setInterval(checkDeadlines, 1000);</pre>
